Texture2D texture2d <string uiname="Texture";>;
Texture2D uvmap <string uiname="UVMap";>;

SamplerState g_samLinear : IMMUTABLE
{
    Filter = MIN_MAG_MIP_LINEAR;
    AddressU = Clamp;
    AddressV = Clamp;
};

 
cbuffer cbPerDraw : register( b0 )
{
	float4x4 tWVP : WORLDVIEWPROJECTION;
	float4 Color <bool color=true;>;
};

struct VS_IN
{
	float4 PosO : POSITION;
	float4 TexCd : TEXCOORD0;
};

struct vs2ps
{
    float4 PosWVP: SV_POSITION;
    float4 TexCd: TEXCOORD0;
};

struct psOut
{
    float4 col : SV_Target0;
    float2 uv : SV_Target1;
};

vs2ps VS(VS_IN input)
{
    vs2ps Out = (vs2ps)0;
    Out.PosWVP  = mul(input.PosO,tWVP);
    Out.TexCd = input.TexCd;
    return Out;
}




psOut PS(vs2ps In)
{
	psOut res;
	res.col = Color;
	res.uv = uvmap.Load(int3(In.PosWVP.xy,0)).rg;
    return res;
}





technique10 Constant
{
	pass P0
	{
		SetVertexShader( CompileShader( vs_4_0, VS() ) );
		SetPixelShader( CompileShader( ps_4_0, PS() ) );
	}
}




